diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java
index 092a9b4fe..ba7343ad4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java
@@ -2,11 +2,15 @@ package net.minecraft.core.world.chunk.reader;
 
 import com.mojang.nbt.tags.CompoundTag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.longs.Long2ObjectMap;
+import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Map;
 
@@ -51,7 +55,13 @@ public class ChunkReaderLegacy
     }
 
     @Override
-    public short[] getBlocks(int ySection)
+    public long getTicksOnUnload() {
+        // Not supported
+        return -1;
+    }
+
+    @Override
+    public short @NotNull [] getBlocks(int ySection)
     {
         short[] newBlocks = new short[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
 
@@ -71,7 +81,7 @@ public class ChunkReaderLegacy
     }
 
     @Override
-    public ChunkUnsignedByteArray getData(int ySection)
+    public @NotNull ChunkUnsignedByteArray getData(int ySection)
     {
         byte[] newData = new byte[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
         ChunkUnsignedByteArray array = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newData);
@@ -92,7 +102,7 @@ public class ChunkReaderLegacy
     }
 
     @Override
-    public ChunkNibbleArray getSkyLight(int ySection)
+    public @NotNull ChunkNibbleArray getSkyLight(int ySection)
     {
         byte[] newSkyLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
         ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newSkyLight);
@@ -121,7 +131,7 @@ public class ChunkReaderLegacy
     }
 
     @Override
-    public ChunkNibbleArray getBlockLight(int ySection)
+    public @NotNull ChunkNibbleArray getBlockLight(int ySection)
     {
         byte[] newBlockLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
         ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newBlockLight);
@@ -150,7 +160,7 @@ public class ChunkReaderLegacy
     }
 
     @Override
-    public short[] getHeightMap()
+    public short @NotNull [] getHeightMap()
     {
         return tag.getShortArrayOrDefault("HeightMap", null);
     }
@@ -183,7 +193,7 @@ public class ChunkReaderLegacy
     }
 
     @Override
-    public byte[] getBiomeMap(int ySection, Int2ObjectMap<String> biomeRegistry)
+    public byte[] getBiomeMap(int ySection, @NotNull Int2ObjectMap<String> biomeRegistry)
     {
         // Not supported
         return null;
@@ -194,4 +204,10 @@ public class ChunkReaderLegacy
         // Not supported
         return null;
     }
+
+    @Override
+    public @Nullable Int2ObjectMap<NextTickListEntry> getTickList() {
+        // Not supported
+        return null;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java
index a2cc78d2a..814e18d21 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java
@@ -2,6 +2,8 @@ package net.minecraft.core.world.chunk.reader;
 
 import com.mojang.nbt.tags.CompoundTag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.longs.Long2ObjectMap;
+import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.world.World;
@@ -9,64 +11,67 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Map;
 
 public class ChunkReaderVersion1
-    extends ChunkReader
-{
+    extends ChunkReader {
     private final short[] blocks;
     private final byte[] data;
     private final byte[] skylight;
     private final byte[] blocklight;
     private final byte[] biome;
 
-    private static int makeBlockIndex(int x, int y, int z) {
+    private static int makeBlockIndex(final int x, final int y, final int z) {
         return (x * 16 * 256) + (z * 256) + y;
     }
 
-    public static int makeBiomeIndex(int x, int y, int z) {
+    public static int makeBiomeIndex(final int x, final int y, final int z) {
         return ((y >> 3) * 16 * 16) + (x * 16) + z;
     }
 
-    private static int makeNibbleIndex(int x, int y, int z) {
+    private static int makeNibbleIndex(final int x, final int y, final int z) {
         return (x * 16 * 256) + (z * 256) + y;
     }
 
-    public ChunkReaderVersion1(World world, CompoundTag tag)
-    {
+    public ChunkReaderVersion1(final @Nullable World world, final @NotNull CompoundTag tag) {
         super(world, tag);
 
-        blocks = tag.getShortArrayOrDefault("Blocks", null);
-        data = tag.getByteArrayOrDefault("Data", null);
-        skylight = tag.getByteArrayOrDefault("SkyLight", null);
-        blocklight = tag.getByteArrayOrDefault("BlockLight", null);
-        biome = tag.getByteArrayOrDefault("BiomeMap", null);
+        this.blocks = tag.getShortArrayOrDefault("Blocks", null);
+        this.data = tag.getByteArrayOrDefault("Data", null);
+        this.skylight = tag.getByteArrayOrDefault("SkyLight", null);
+        this.blocklight = tag.getByteArrayOrDefault("BlockLight", null);
+        this.biome = tag.getByteArrayOrDefault("BiomeMap", null);
     }
 
     @Override
-    public int getX()
-    {
-        return tag.getInteger("xPos");
+    public int getX() {
+        return this.tag.getInteger("xPos");
     }
 
     @Override
-    public int getZ()
-    {
-        return tag.getInteger("zPos");
+    public int getZ() {
+        return this.tag.getInteger("zPos");
     }
 
     @Override
-    public short[] getBlocks(int ySection)
-    {
-        short[] newBlocks = new short[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
+    public long getTicksOnUnload() {
+        // Not supported
+        return -1;
+    }
+
+    @Override
+    public short @NotNull [] getBlocks(final int ySection) {
+        final short[] newBlocks = new short[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
 
-        if (blocks != null && makeBlockIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < blocks.length) {
+        if (this.blocks != null && makeBlockIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < this.blocks.length) {
             for (int x = 0; x < 16; x++) {
                 for (int z = 0; z < 16; z++) {
                     for (int y = 0; y < 16; y++) {
-                        int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
-                        short id = this.blocks[makeBlockIndex(x, yOffset + y, z)];
+                        final int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
+                        final short id = this.blocks[makeBlockIndex(x, yOffset + y, z)];
                         newBlocks[ChunkSection.makeBlockIndex(x, y, z)] = id;
                     }
                 }
@@ -77,17 +82,16 @@ public class ChunkReaderVersion1
     }
 
     @Override
-    public ChunkUnsignedByteArray getData(int ySection)
-    {
-        byte[] newData = new byte[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
-        ChunkUnsignedByteArray array = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newData);
+    public @NotNull ChunkUnsignedByteArray getData(final int ySection) {
+        final byte[] newData = new byte[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
+        final ChunkUnsignedByteArray array = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newData);
 
-        if (data != null && makeBlockIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < data.length) {
+        if (this.data != null && makeBlockIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < this.data.length) {
             for (int x = 0; x < 16; x++) {
                 for (int z = 0; z < 16; z++) {
                     for (int y = 0; y < 16; y++) {
-                        int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
-                        byte data = this.data[makeBlockIndex(x, yOffset + y, z)];
+                        final int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
+                        final byte data = this.data[makeBlockIndex(x, yOffset + y, z)];
                         array.set(x, y, z, Byte.toUnsignedInt(data));
                     }
                 }
@@ -98,24 +102,23 @@ public class ChunkReaderVersion1
     }
 
     @Override
-    public ChunkNibbleArray getSkyLight(int ySection)
-    {
-        byte[] newSkyLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
-        ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newSkyLight);
+    public @NotNull ChunkNibbleArray getSkyLight(final int ySection) {
+        final byte[] newSkyLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
+        final ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newSkyLight);
 
-        if (skylight != null && makeNibbleIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < skylight.length * 2) {
+        if (this.skylight != null && makeNibbleIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < this.skylight.length * 2) {
             for (int x = 0; x < 16; x++) {
                 for (int z = 0; z < 16; z++) {
                     for (int y = 0; y < 16; y++) {
-                        int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
-                        int index = makeNibbleIndex(x, yOffset + y, z);
-                        int nibbleIndex = index >> 1;
-                        int nibblePart = index & 0x01;
-                        int nibble;
+                        final int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
+                        final int index = makeNibbleIndex(x, yOffset + y, z);
+                        final int nibbleIndex = index >> 1;
+                        final int nibblePart = index & 0x01;
+                        final int nibble;
                         if (nibblePart == 0) {
-                            nibble = Byte.toUnsignedInt(skylight[nibbleIndex]) & 0x0F;
+                            nibble = Byte.toUnsignedInt(this.skylight[nibbleIndex]) & 0x0F;
                         } else {
-                            nibble = (Byte.toUnsignedInt(skylight[nibbleIndex]) >> 4) & 0x0F;
+                            nibble = (Byte.toUnsignedInt(this.skylight[nibbleIndex]) >> 4) & 0x0F;
                         }
                         array.set(x, y, z, nibble);
                     }
@@ -127,24 +130,23 @@ public class ChunkReaderVersion1
     }
 
     @Override
-    public ChunkNibbleArray getBlockLight(int ySection)
-    {
-        byte[] newBlockLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
-        ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newBlockLight);
+    public @NotNull ChunkNibbleArray getBlockLight(final int ySection) {
+        final byte[] newBlockLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
+        final ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newBlockLight);
 
-        if (blocklight != null && makeNibbleIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < blocklight.length * 2) {
+        if (this.blocklight != null && makeNibbleIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < this.blocklight.length * 2) {
             for (int x = 0; x < 16; x++) {
                 for (int z = 0; z < 16; z++) {
                     for (int y = 0; y < 16; y++) {
-                        int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
-                        int index = makeNibbleIndex(x, yOffset + y, z);
-                        int nibbleIndex = index >> 1;
-                        int nibblePart = index & 0x01;
-                        int nibble;
+                        final int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
+                        final int index = makeNibbleIndex(x, yOffset + y, z);
+                        final int nibbleIndex = index >> 1;
+                        final int nibblePart = index & 0x01;
+                        final int nibble;
                         if (nibblePart == 0) {
-                            nibble = Byte.toUnsignedInt(blocklight[nibbleIndex]) & 0x0F;
+                            nibble = Byte.toUnsignedInt(this.blocklight[nibbleIndex]) & 0x0F;
                         } else {
-                            nibble = (Byte.toUnsignedInt(blocklight[nibbleIndex]) >> 4) & 0x0F;
+                            nibble = (Byte.toUnsignedInt(this.blocklight[nibbleIndex]) >> 4) & 0x0F;
                         }
                         array.set(x, y, z, nibble);
                     }
@@ -156,53 +158,47 @@ public class ChunkReaderVersion1
     }
 
     @Override
-    public short[] getHeightMap()
-    {
-        return tag.getShortArrayOrDefault("HeightMap", null);
+    public short @NotNull [] getHeightMap() {
+        return this.tag.getShortArrayOrDefault("HeightMap", null);
     }
 
     @Override
-    public int getAverageBlockHeight()
-    {
-        return tag.getInteger("AverageBlockHeight");
+    public int getAverageBlockHeight() {
+        return this.tag.getInteger("AverageBlockHeight");
     }
 
     @Override
-    public boolean getIsTerrainPopulated()
-    {
-        return tag.getBoolean("TerrainPopulated");
+    public boolean getIsTerrainPopulated() {
+        return this.tag.getBoolean("TerrainPopulated");
     }
 
     @Override
-    public double[] getTemperatureMap()
-    {
-        return tag.getDoubleArray("TemperatureMap");
+    public double[] getTemperatureMap() {
+        return this.tag.getDoubleArray("TemperatureMap");
     }
 
     @Override
-    public double[] getHumidityMap()
-    {
-        return tag.getDoubleArray("HumidityMap");
+    public double[] getHumidityMap() {
+        return this.tag.getDoubleArray("HumidityMap");
     }
 
     @Override
-    public byte[] getBiomeMap(int ySection, Int2ObjectMap<String> biomeRegistry)
-    {
-        byte[] newBiomes = new byte[Chunk.CHUNK_SIZE_X * (ChunkSection.SECTION_SIZE_Y >> 3) * Chunk.CHUNK_SIZE_Z];
+    public byte[] getBiomeMap(final int ySection, @NotNull final Int2ObjectMap<String> biomeRegistry) {
+        final byte[] newBiomes = new byte[Chunk.CHUNK_SIZE_X * (ChunkSection.SECTION_SIZE_Y >> 3) * Chunk.CHUNK_SIZE_Z];
 
-        if (biome != null && makeBiomeIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < biome.length) {
+        if (this.biome != null && makeBiomeIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < this.biome.length) {
             for (int x = 0; x < 16; x++) {
                 for (int z = 0; z < 16; z++) {
                     for (int y = 0; y < 16; y++) {
-                        int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
-                        byte oldBiomeId = biome[makeBiomeIndex(x, yOffset + y, z)];
+                        final int yOffset = ySection * ChunkSection.SECTION_SIZE_Y;
+                        final byte oldBiomeId = this.biome[makeBiomeIndex(x, yOffset + y, z)];
                         if (oldBiomeId < 0) {
                             newBiomes[ChunkSection.makeBiomeIndex(x, y, z)] = oldBiomeId;
                         } else {
                             try {
-                                byte newBiomeId = (byte) Registries.BIOMES.getNumericIdOfItem(Registries.BIOMES.getItem(biomeRegistry.get((int) oldBiomeId)));
+                                final byte newBiomeId = (byte) Registries.BIOMES.getNumericIdOfItem(Registries.BIOMES.getItem(biomeRegistry.get(oldBiomeId)));
                                 newBiomes[ChunkSection.makeBiomeIndex(x, y, z)] = newBiomeId;
-                            } catch (NullPointerException n){
+                            } catch (final NullPointerException n) {
                                 newBiomes[ChunkSection.makeBiomeIndex(x, y, z)] = -1;
                             }
                         }
@@ -216,19 +212,23 @@ public class ChunkReaderVersion1
 
     @Override
     public Int2ObjectMap<String> getBiomeRegistry() {
-        CompoundTag registriesTag = tag.getCompoundOrDefault("Registries", null);
+        final CompoundTag registriesTag = this.tag.getCompoundOrDefault("Registries", null);
         CompoundTag biomesTag = null;
-        if (registriesTag != null)
-        {
+        if (registriesTag != null) {
             biomesTag = registriesTag.getCompoundOrDefault("Biomes", null);
         }
 
-        if (registriesTag == null || biomesTag == null)
-        {
+        if (registriesTag == null || biomesTag == null) {
             // Give up on conversion as we can't really interpret this data meaningfully
             return null;
         }
 
         return Registry.readIdMapFromTag(biomesTag);
     }
+
+    @Override
+    public @Nullable Int2ObjectMap<NextTickListEntry> getTickList() {
+        // Not supported
+        return null;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java
index 51b3725c3..4de091930 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java
@@ -4,6 +4,8 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import com.mojang.nbt.tags.Tag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.longs.Long2ObjectMap;
+import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.world.World;
@@ -11,6 +13,8 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Arrays;
 import java.util.Map;
@@ -50,7 +54,13 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public short[] getBlocks(int ySection) {
+    public long getTicksOnUnload() {
+        // Not supported
+        return -1;
+    }
+
+    @Override
+    public short @NotNull [] getBlocks(int ySection) {
         short[] blocks = null;
         CompoundTag sectionTag = findSection(ySection);
         if (sectionTag != null) {
@@ -61,7 +71,7 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public ChunkUnsignedByteArray getData(int ySection) {
+    public @NotNull ChunkUnsignedByteArray getData(int ySection) {
         byte[] data = null;
         CompoundTag sectionTag = findSection(ySection);
         if (sectionTag != null) {
@@ -76,7 +86,7 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public ChunkNibbleArray getSkyLight(int ySection) {
+    public @NotNull ChunkNibbleArray getSkyLight(int ySection) {
         byte[] skylight = null;
         CompoundTag sectionTag = findSection(ySection);
         if (sectionTag != null) {
@@ -91,7 +101,7 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public ChunkNibbleArray getBlockLight(int ySection) {
+    public @NotNull ChunkNibbleArray getBlockLight(int ySection) {
         byte[] blocklight = null;
         CompoundTag sectionTag = findSection(ySection);
         if (sectionTag != null) {
@@ -106,7 +116,7 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public short[] getHeightMap() {
+    public short @NotNull [] getHeightMap() {
         return tag.getShortArrayOrDefault("HeightMap", null);
     }
 
@@ -131,7 +141,7 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public byte[] getBiomeMap(int ySection, Int2ObjectMap<String> biomeRegistry) {
+    public byte[] getBiomeMap(int ySection, @NotNull Int2ObjectMap<String> biomeRegistry) {
         byte[] biomeMap = null;
         CompoundTag sectionTag = findSection(ySection);
         if (sectionTag != null) {
@@ -174,4 +184,10 @@ public class ChunkReaderVersion2
 
         return Registry.readIdMapFromTag(biomesTag);
     }
+
+    @Override
+    public @Nullable Int2ObjectMap<NextTickListEntry> getTickList() {
+        // Not supported
+        return null;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java
new file mode 100644
index 000000000..ba5d71691
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java
@@ -0,0 +1,207 @@
+package net.minecraft.core.world.chunk.reader;
+
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.Tag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.longs.Long2ObjectArrayMap;
+import it.unimi.dsi.fastutil.longs.Long2ObjectMap;
+import net.minecraft.core.NextTickListEntry;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.Registry;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.chunk.ChunkSection;
+import net.minecraft.core.world.data.ChunkNibbleArray;
+import net.minecraft.core.world.data.ChunkUnsignedByteArray;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Arrays;
+
+public class ChunkReaderVersion3
+    extends ChunkReader {
+    private final @NotNull ListTag sectionsTag;
+
+    public ChunkReaderVersion3(final @Nullable World world, final @NotNull CompoundTag chunkTag) {
+        super(world, chunkTag);
+
+        this.sectionsTag = chunkTag.getList("Sections");
+    }
+
+    private @Nullable CompoundTag findSection(final int y) {
+        for (final @NotNull Tag<?> tag : this.sectionsTag) {
+            if (tag instanceof CompoundTag) {
+                final @NotNull CompoundTag cTag = (CompoundTag) tag;
+                final int tagY = cTag.getInteger("yPos");
+                if (tagY == y) {
+                    return cTag;
+                }
+            }
+        }
+
+        return null;
+    }
+
+    @Override
+    public int getX() {
+        return this.tag.getInteger("xPos");
+    }
+
+    @Override
+    public int getZ() {
+        return this.tag.getInteger("zPos");
+    }
+
+    @Override
+    public long getTicksOnUnload() {
+        return this.tag.getLong("TicksOnUnload");
+    }
+
+    @Override
+    public short @Nullable [] getBlocks(final int ySection) {
+        short @Nullable [] blocks = null;
+        final @Nullable CompoundTag sectionTag = this.findSection(ySection);
+        if (sectionTag != null) {
+            blocks = sectionTag.getShortArrayOrDefault("Blocks", null);
+        }
+
+        return blocks;
+    }
+
+    @Override
+    public @Nullable ChunkUnsignedByteArray getData(final int ySection) {
+        byte[] data = null;
+        final @Nullable CompoundTag sectionTag = this.findSection(ySection);
+        if (sectionTag != null) {
+            data = sectionTag.getByteArrayOrDefault("Data", null);
+        }
+
+        if (data == null) {
+            return null;
+        }
+
+        return new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, data);
+    }
+
+    @Override
+    public @Nullable ChunkNibbleArray getSkyLight(final int ySection) {
+        byte @Nullable [] skylight = null;
+        final CompoundTag sectionTag = this.findSection(ySection);
+        if (sectionTag != null) {
+            skylight = sectionTag.getByteArrayOrDefault("SkyLight", null);
+        }
+
+        if (skylight == null) {
+            return null;
+        }
+
+        return new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, skylight);
+    }
+
+    @Override
+    public @Nullable ChunkNibbleArray getBlockLight(final int ySection) {
+        byte @Nullable [] blocklight = null;
+        final CompoundTag sectionTag = this.findSection(ySection);
+        if (sectionTag != null) {
+            blocklight = sectionTag.getByteArrayOrDefault("BlockLight", null);
+        }
+
+        if (blocklight == null) {
+            return null;
+        }
+
+        return new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, blocklight);
+    }
+
+    @Override
+    public short @Nullable [] getHeightMap() {
+        return this.tag.getShortArrayOrDefault("HeightMap", null);
+    }
+
+    @Override
+    public int getAverageBlockHeight() {
+        return this.tag.getInteger("AverageBlockHeight");
+    }
+
+    @Override
+    public boolean getIsTerrainPopulated() {
+        return this.tag.getBoolean("TerrainPopulated");
+    }
+
+    @Override
+    public double @Nullable [] getTemperatureMap() {
+        return this.tag.getDoubleArray("TemperatureMap");
+    }
+
+    @Override
+    public double @Nullable [] getHumidityMap() {
+        return this.tag.getDoubleArray("HumidityMap");
+    }
+
+    @Override
+    public byte @Nullable [] getBiomeMap(final int ySection, @NotNull final Int2ObjectMap<String> biomeRegistry) {
+        byte[] biomeMap = null;
+        final CompoundTag sectionTag = this.findSection(ySection);
+        if (sectionTag != null) {
+            biomeMap = sectionTag.getByteArrayOrDefault("BiomeMap", null);
+        }
+
+        if (biomeMap == null) {
+            biomeMap = new byte[Chunk.CHUNK_SIZE_X * (ChunkSection.SECTION_SIZE_Y >> 3) * Chunk.CHUNK_SIZE_Z];
+            Arrays.fill(biomeMap, (byte) -1);
+        } else {
+            for (int i = 0; i < biomeMap.length; i++) {
+                final byte oldBiomeId = biomeMap[i];
+                if (oldBiomeId >= 0) {
+                    try {
+                        biomeMap[i] = (byte) Registries.BIOMES.getNumericIdOfItem(Registries.BIOMES.getItem(biomeRegistry.get(oldBiomeId)));
+                    } catch (final NullPointerException n) {
+                        biomeMap[i] = -1;
+                    }
+                }
+            }
+        }
+
+        return biomeMap;
+    }
+
+    @Override
+    public @Nullable Int2ObjectMap<String> getBiomeRegistry() {
+        final @Nullable CompoundTag registriesTag = this.tag.getCompoundOrDefault("Registries", null);
+        CompoundTag biomesTag = null;
+        if (registriesTag != null) {
+            biomesTag = registriesTag.getCompoundOrDefault("Biomes", null);
+        }
+
+        if (registriesTag == null || biomesTag == null) {
+            // Give up on conversion as we can't really interpret this data meaningfully
+            return null;
+        }
+
+        return Registry.readIdMapFromTag(biomesTag);
+    }
+
+    @Override
+    public @Nullable Int2ObjectMap<NextTickListEntry> getTickList() {
+        final @Nullable ListTag ticksTag = this.tag.getListOrDefault("TicksList", null);
+        if (ticksTag == null) {
+            return null;
+        }
+
+        final @NotNull Int2ObjectMap<NextTickListEntry> entries = new Int2ObjectArrayMap<>();
+        for (final @NotNull Tag<?> tag : ticksTag) {
+            if (tag instanceof CompoundTag) {
+                final @NotNull CompoundTag tickTag = (CompoundTag) tag;
+                final @Nullable NextTickListEntry entry = NextTickListEntry.deserialize(tickTag);
+                if (entry != null) {
+                    final int compressed = NextTickListEntry.compressChunkCoord((short) entry.x, (short) entry.y, (short) entry.z);
+                    entries.put(compressed, entry);
+                }
+            }
+        }
+
+        return entries;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java b/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java
index 7b577d987..d671296c8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java
@@ -3,11 +3,14 @@ package net.minecraft.core.world.chunk.writer;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import com.mojang.nbt.tags.Tag;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
+import org.jetbrains.annotations.NotNull;
 
 public class ChunkWriter
 {
@@ -56,9 +59,8 @@ public class ChunkWriter
         tag.putInt("zPos", zPos);
     }
 
-    public void putLastUpdate(long lastUpdate)
-    {
-        tag.putLong("LastUpdate", lastUpdate);
+    public void putTicksOnUnload(final long ticksAtUnload) {
+        this.tag.putLong("TicksOnUnload", ticksAtUnload);
     }
 
     public void putBlocks(int ySection, short[] blocks)
@@ -118,4 +120,13 @@ public class ChunkWriter
         registriesTag.putCompound("Biomes", biomesTag);
         tag.putCompound("Registries", registriesTag);
     }
+
+    public void putTickList(final @NotNull Int2ObjectMap<NextTickListEntry> entries) {
+        final @NotNull ListTag ticksTag = new ListTag();
+        for (final @NotNull NextTickListEntry entry : entries.values()) {
+            ticksTag.addTag(NextTickListEntry.serialize(entry));
+        }
+
+        this.tag.putList("TicksList", ticksTag);
+    }
 }
